/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* Assignment 2                                                */
/* 9/30/98                                                     */
/***************************************************************/

import java.applet.*;
import java.awt.*;

public class Assignment2 extends Applet implements Runnable
{

  //Dynamic transofrmation values
  protected double fAngle;
  protected double fScaleX;
  protected double fScaleY;
  protected boolean fGrowX;

  //Geometric shapes
  protected MyLine fLine;
  protected MyRectangle fRect;
  protected MyEllipse fEllipse;
  protected MyPoly fPoly;

  //Transformations
  protected Xform fTranslate;
  protected Xform fRotate;
  protected Xform fScale;
  protected Xform fCurrent;

  //Thread
  protected Thread fThread;

  public void init ()
  {
    //Triangle coordinates
    double x[] = {0.10, 0.30, 0.50};
    double y[] = {0.20, 0.50, 0.20};

    setLayout(new BorderLayout());
    //defaults
    fAngle = 0.0;
    fScaleX = 0.0;
    fScaleY = 2.0;
    fGrowX = true;

    //shapes
    fRect = new MyRectangle (0.25, 0.25, 0.75, 0.75);
    fLine = new MyLine (0.75, 0.75, 0.25, 0.25);
    fEllipse = new MyEllipse (0.5, 0.5, 0.25, 0.4);
    fPoly = new MyPoly (x, y, 3);

    //translations
    fTranslate = new Xform ();
    fRotate = new Xform ();
    fCurrent = new Xform ();
    fScale = new Xform ();

    fThread = new Thread (this);
  } // init

  public void paint (Graphics g)
  {
    //Off screen buffer for double buffering
    Image image = createImage (300, 300);
    Graphics buffer = image.getGraphics ();

    //Triangle coordinates
    double x[] = {0.10, 0.30, 0.50};
    double y[] = {0.20, 0.50, 0.20};

    //Clear background and set color
    buffer.setColor (getBackground ());
    buffer.fillRect (0, 0, 300, 300);
    buffer.setColor (Color.black);

    //Set shapes to default
    fRect = new MyRectangle (0.25, 0.25, 0.75, 0.75);
    fLine = new MyLine (0.75, 0.75, 0.25, 0.25);
    fPoly = new MyPoly (x, y, 3);
    fEllipse = new MyEllipse (0.5, 0.5, 0.25, 0.4);

    //Clean up old values
    System.gc ();

    //Increment angle
    fAngle += 1.0;
    if (fAngle > 360.0) 
      fAngle = 0.0;

    //Set scale value
    if (fGrowX)
    {
      fScaleX += 0.1;
      fScaleY -= 0.1;
      if (fScaleX >= 2.0)
        fGrowX = false;
    }
    else
    {
      fScaleX -= 0.1;
      fScaleY += 0.1;
      if (fScaleX <= 0.0)
        fGrowX = true;
    }

    //Move the rectangle to the center
    //Rotate the rectangle around the center
    //Move the rectangle back
    fCurrent.setIdentity();
    fTranslate.setTranslate (-0.5, -0.5);
    fRotate.setRotate (fAngle);
    fCurrent.preCompose (fTranslate);
    fCurrent.preCompose (fRotate);
    fTranslate.setTranslate (0.5, 0.5);
    fCurrent.preCompose (fTranslate);

    fRect.apply (fCurrent);
    fRect.render (buffer);

    //Move the line to the center
    //Rotate the line around the center
    //Move the rectangle back
    fCurrent.setIdentity();
    fTranslate.setTranslate (-0.5, -0.5);
    fRotate.setRotate (360.0 - fAngle);
    fCurrent.preCompose (fTranslate);
    fCurrent.preCompose (fRotate);
    fTranslate.setTranslate (0.5, 0.5);
    fCurrent.preCompose (fTranslate);

    fLine.apply (fCurrent);
    fLine.render (buffer);

    //Scale the triangle
    fCurrent.setIdentity();
    fTranslate.setTranslate (-0.3, -0.35);
    fScale.setScale (fScaleX, fScaleY);
    fCurrent.preCompose (fTranslate);
    fCurrent.preCompose (fScale);
    fTranslate.setTranslate (0.3, 0.35);
    fCurrent.preCompose (fTranslate);
    fPoly.apply (fCurrent);
    fPoly.render (buffer);


    //Scale the Ellipse
    fCurrent.setIdentity();
    fTranslate.setTranslate (-0.5, -0.5);
    fScale.setScale (fScaleY, fScaleX);
    fCurrent.preCompose (fTranslate);
    fCurrent.preCompose (fScale);
    fTranslate.setTranslate (0.5, 0.5);
    fCurrent.preCompose (fTranslate);
    fEllipse.apply (fCurrent);
    fEllipse.render (buffer);

    //Swap buffers
    g.drawImage (image, 0, 0, this);
  } //paint

  public void stop () 
  {
    fThread.stop ();
  }

  public void start () 
  {
    fThread.start ();
  }

  public void update (Graphics g)
  {
    paint (g);
  }

  public void run ()
  {
    while (true)
    {
      try 
      {
        fThread.sleep(50);
      } 
      catch (InterruptedException e){}
      repaint ();
    }
  }

} //Assignment2
