/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* 9/16/98                                                     */
/* 9/30/98                                                     */
/***************************************************************/

import java.awt.*;

class MyEllipse extends MyGraphicalObject
{

  protected Point2d fLeftCorner;      //Top Left Corner
  protected Point2d fRightCorner;     //Bottom Right Corner
 
  MyEllipse (double xc, double yc, double width, double height)
  {

    //Store coordinates as bounding box corners for transformations
    fLeftCorner = new Point2d (xc - width/2, yc + height/2);
    fRightCorner = new Point2d (xc + width/2, yc - height/2);

  } //MyEllipse

  public void render (Graphics g)
  {
    //Draw ellipse within specified boundaries, 
    //converting bottom right corner values to width and height
    g.drawOval (ConvertX (fLeftCorner.fX), 
                ConvertY (fLeftCorner.fY), 
                ConvertX (fRightCorner.fX - fLeftCorner.fX), 
                ConvertYRaw (fLeftCorner.fY - fRightCorner.fY));
  } //render

  public void apply (Xform x)
  {
    //Transform points
    x.apply (fLeftCorner);
    x.apply (fRightCorner);
  } //apply

} //MyEllipse
