/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* 9/16/98                                                     */
/* 9/30/98                                                     */
/***************************************************************/

import java.awt.*;

abstract class MyGraphicalObject
{

  //Instance methods

  //Currently represent width and height of canvas
  //The applet is set to 300x300 which means a range of 0-299
  //Or max values of width-1 and height-1
  private int MaxX;
  private int MaxY;

  //Constructor
  public MyGraphicalObject ()
  {
    MaxX = 300 - 1;
    MaxY = 300 - 1;
  }

  //Instance methods

  //Method to do Cartesian to pixel conversions for X axis
  protected int ConvertX (double x)
  {
    return (int) Math.round (x * ((double) MaxX));
  } //ConvertX

  //Method to do Cartesian to pixel conversions for Y axis
  //without directional adjustment
  protected int ConvertYRaw (double y)
  {
    return (int) Math.round (y * ((double) MaxY));
  } //ConvertY

  //Method to do Cartesian to pixel conversions for Y axis
  protected int ConvertY (double y)
  {
    return (MaxY - ConvertYRaw (y));
  } //ConvertY

  //Pure virtual render method
  public abstract void render (Graphics g);

  //Pure virtual transformation apply method
  public abstract void apply (Xform x);

} //MyGraphicalObject
