/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* 9/16/98                                                     */
/***************************************************************/

import java.awt.*;

class MyPoly extends MyGraphicalObject
{

  protected Point2d fPoints[];      //Vertices
  protected int fNVerts;            //Number of vertices
 
  //Default constructor for subclasses
  MyPoly ()
  {
  }

  MyPoly (double x[], double y[], int nverts)
  {
    fPoints = new Point2d[nverts];
    fNVerts = nverts;
    
    for (int i = 0; i < nverts; i++)
    {
      fPoints[i] = new Point2d (x[i], y[i]);
    }
  } //MyPoly

  public void render (Graphics g)
  {
    //Copy points to arrays
    int xPoints[] = new int[fNVerts];
    int yPoints[] = new int[fNVerts];
    int i;

    for (i = 0; i < fNVerts; i++)
    {
      xPoints[i] = ConvertX (fPoints[i].fX); 
      yPoints[i] = ConvertY (fPoints[i].fY); 
    }

    g.drawPolygon (xPoints, yPoints, fNVerts);
  } //render

  public void apply (Xform x)
  {
    int i;

    for (i = 0; i < fNVerts; i++)
    {
      //Apply transformation to each point
      fPoints[i] = x.apply (fPoints[i]);
    }
  } //apply

} //MyPoly
